\ wireless scan logger
\ logs wireless scans for analysis
visible

d#  1 value wsl-channel                  \ the channel to use (in decimal)
false value wsl-passive                  \ whether to use passive scan
d#  3 value wsl-time                     \ pause between tests

\ ------------------------------------------------------------------------------

: .mac  ( adr len -- )
   push-hex drop  5 0  do
      dup c@ (.2) type  ." :"  1+
   loop
   c@ (.2) type  pop-base
;

\ ------------------------------------------------------------------------------

: wsl-header  ( -- )
   collect(
   ." wireless scan logger" cr
   time&date >unix-seconds " %d" printf  ."  \ timestamp"    cr
   " get-mac-address" $call-wlan .mac    ."  \ mac address"  cr
   wsl-channel .d                        ." \ channel"       cr
   wsl-passive .d                        ." \ passive"       cr
   cr
   )collect

   \ delete file if already present
   make-sn-name 2dup ['] $delete catch if
      2drop
   then                                 ( $text $file )
   2dup type cr				( $text $file )
   $create-file dup 0= abort" Can't create file"
   >r " write" r@ $call-method drop r> close-dev ( )
;

: wsl-pause
   begin
      time&date >unix-seconds wsl-time mod key? 0= and
   while
      d# 100 ms
   repeat
;

: wsl-scan
   wsl-passive if
      ." scanning (passive)      ... "
   else
      ." scanning (active)       ... "
   then

   collect(
   time&date >unix-seconds " %d" printf  cr
   t( " ta-scan" $call-wlan cr )t cr
   )collect ( $text )

   dup .d ." bytes " cr
   2dup type

   ." writing to USB log file ... "
   make-sn-name $append-open
   ofd @ fputs
   ofd @ close-file drop

   ." ok" cr
;

: wsl-postpause
   begin
      time&date >unix-seconds wsl-time mod 0= key? 0= and
   while
      d# 100 ms
   repeat
;

: wsl

   ." wireless scan logger" cr
   ." v1.0 2014-02-10 quozl@laptop.org" cr cr

   ." opening wireless device ... "
   " /wlan:force" open-dev to wlan-ih        \ avoids automatic association
   wlan-ih 0= abort" Can't open wireless LAN"
   ." ok" cr

   wsl-passive if
      ." set passive scan mode   ... "
      " passive-scan" $call-wlan
      ." ok" cr
   then

   ." check for MAC address   ... "
   " get-mac-address" $call-wlan .mac ."  ok" cr

   ." opening USB log file    ... "
   wsl-header

   begin
      wsl-pause
      key? 0= if wsl-scan then
      wsl-postpause
      key?
   until
   flush-keyboard

   ." closing wireless device ... "
   close-wlan
   ." ok" cr
   cr
;

wsl
\ leave user at ok prompt with network off
